﻿Imports System.IO
Imports System.Runtime.Serialization.Formatters.Binary
Imports System.Runtime.Serialization.Formatters.Soap

Public Class Form1

    Private Sub bttnSerializeSimple_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnSerializeSimple.Click
        Dim R1 As New Rectangle()
        R1.X = 1
        R1.Y = 1
        R1.Width = 10
        R1.Height = 20
        Dim R2 As New Rectangle()
        R2.X = 10
        R2.Y = 10
        R2.Width = 100
        R2.Height = 200
        Dim saveFile As FileStream
        Dim fileName As String = "..\..\..\SHAPES.BIN"
        saveFile = File.Create(filename)
        Dim BFormatter As New BinaryFormatter
        Try
            BFormatter.Serialize(saveFile, R1)
            BFormatter.Serialize(saveFile, R2)
        Catch ex As Exception
            MsgBox("Failed to serialize objects:" & vbCrLf & ex.Message)
            saveFile.Close()
            Exit Sub
        End Try
        saveFile.Close()
        MsgBox("Objects serialized successfully")
    End Sub

    Private Sub bttnDeserializeSimple_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bttnDeserializeSimple.Click
        Dim BFormatter As New BinaryFormatter
        Dim Strm As New FileStream("..\..\..\SHAPES.BIN", FileMode.Open)
        Dim R1, R2 As Rectangle
        R1 = CType(BFormatter.Deserialize(Strm), Rectangle)
        R2 = CType(BFormatter.Deserialize(Strm), Rectangle)
        Strm.Close()
        TextBox1.Clear()
        TextBox1.AppendText(R1.ToString)
        TextBox1.AppendText(vbCrLf)
        TextBox1.AppendText(R2.ToString)
        TextBox1.AppendText(vbCrLf)
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim R1 As New Rectangle()
        R1.X = 1
        R1.Y = 1
        R1.Width = 10
        R1.Height = 20
        Dim R2 As New Rectangle()
        R2.X = 10
        R2.Y = 10
        R2.Width = 100
        R2.Height = 200
        Dim saveFile As FileStream
        Dim fileName As String = "..\..\..\SHAPES.XML"
        saveFile = File.Create(fileName)
        Dim SFormatter As New SoapFormatter
        Try
            SFormatter.Serialize(saveFile, R1)
            SFormatter.Serialize(saveFile, R2)
        Catch ex As Exception
            MsgBox("Failed to serialize objects:" & vbCrLf & ex.Message)
            saveFile.Close()
            Exit Sub
        End Try
        saveFile.Close()
        MsgBox("Objects serialized successfully")
        TextBox1.Text = My.Computer.FileSystem.ReadAllText(fileName)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim SFormatter As New SoapFormatter
        Dim Strm As New FileStream("..\..\..\SHAPES.XML", FileMode.Open)
        Dim R1, R2 As Rectangle
        R1 = CType(SFormatter.Deserialize(Strm), Rectangle)
        R2 = CType(SFormatter.Deserialize(Strm), Rectangle)
        Strm.Close()
        TextBox1.Clear()
        TextBox1.AppendText(R1.ToString)
        TextBox1.AppendText(vbCrLf)
        TextBox1.AppendText(R2.ToString)
        TextBox1.AppendText(vbCrLf)
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim R1 As New Rectangle()
        R1.X = 1
        R1.Y = 1
        R1.Width = 10
        R1.Height = 20
        Dim R2 As New Rectangle()
        R2.X = 10
        R2.Y = 10
        R2.Width = 100
        R2.Height = 200
        Dim Shapes As New ArrayList
        Shapes.Add(R1)
        Shapes.Add(R2)
        Dim saveFile As FileStream
        Dim fileName As String = "..\..\..\SHAPES.BIN"
        saveFile = File.Create(fileName)
        Dim BFormatter As New BinaryFormatter
        Try
            BFormatter.Serialize(saveFile, Shapes)
        Catch ex As Exception
            MsgBox("Failed to serialize objects:" & vbCrLf & ex.Message)
            saveFile.Close()
            Exit Sub
        End Try
        saveFile.Close()
        MsgBox("Objects serialized successfully")
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim SFormatter As New SoapFormatter
        Dim Strm As New FileStream("..\..\..\SHAPES.BIN", FileMode.Open)
        Dim Shapes As New ArrayList
        Shapes = CType(SFormatter.Deserialize(Strm), ArrayList)
        Strm.Close()
        TextBox1.Clear()
        TextBox1.AppendText(Shapes(0).ToString)
        TextBox1.AppendText(vbCrLf)
        TextBox1.AppendText(Shapes(1).ToString)
        TextBox1.AppendText(vbCrLf)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim R1 As New Rectangle()
        R1.X = 1
        R1.Y = 1
        R1.Width = 10
        R1.Height = 20
        Dim R2 As New Rectangle()
        R2.X = 10
        R2.Y = 10
        R2.Width = 100
        R2.Height = 200
        Dim Shapes As New ArrayList
        Shapes.Add(R1)
        Shapes.Add(R2)
        Dim saveFile As FileStream
        Dim fileName As String = "..\..\..\SHAPES.XML"
        saveFile = File.Create(fileName)
        Dim SFormatter As New SoapFormatter
        Try
            SFormatter.Serialize(saveFile, Shapes)
        Catch ex As Exception
            MsgBox("Failed to serialize objects:" & vbCrLf & ex.Message)
            saveFile.Close()
            Exit Sub
        End Try
        saveFile.Close()
        MsgBox("Objects serialized successfully")
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim SFormatter As New SoapFormatter
        Dim Strm As New FileStream("..\..\..\SHAPES.XML", FileMode.Open)
        Dim Shapes As New ArrayList
        Shapes = CType(SFormatter.Deserialize(Strm), ArrayList)
        Strm.Close()
        TextBox1.Clear()
        TextBox1.AppendText(Shapes(0).ToString)
        TextBox1.AppendText(vbCrLf)
        TextBox1.AppendText(Shapes(1).ToString)
        TextBox1.AppendText(vbCrLf)
    End Sub
End Class
